package Ennemi;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

import game.Fireball;
import game.Game;
import game.Heros;

public class SlimeBall implements Ennemi{

	public static SpriteSheet sp;
	private int hp;
	private boolean alive;
	private String direction;
	private int x,y,dx,dy;
	private Rectangle rec;
	private int cptAnimation = 39, cptAnimationMort,cptDeplacement,phaseDeplacement,cptPause;

	public SlimeBall(int x, int y, int dx, int dy){
		this.x = x;
		this.y = y;
		this.dx = dx;
		this.dy = dy;
		cptDeplacement=(int)(Math.random()*200);
		rec = new Rectangle(x,y,8,8);
		alive = true;
	}

	public boolean isAlive() {
		if(alive==true){
			return true;
			//code a faire
		}else{
			return false;
		}
	}

	public void render() {	
		if(alive){
			sp.getSprite(0, 0).draw(x,y);
			if(Game.DEBUG_HITBOX)Game.graphics.draw(rec);
		}

	}

	public void update(Heros heros) {
		if(alive){
			////////////////////////////////////////
			// DEPLACEMENT
			if(cptDeplacement>0){
				if(!Game.getMapCourante().isBlocked(x+12+5*dx, y+12,true,false)){
					this.x += dx;
				}else{
					if(dx!=0){
						this.detruire();
					}
				}
				if(!Game.getMapCourante().isBlocked(x+12, y+12+5*dy,true,false)){
					this.y += dy;
				}else{
					if(dy!=0){
						this.detruire();
					}
				}
					
				
				cptDeplacement--;
			}else{
				alive = false;
			}

			
			////////////////////////////////////////
			// COLLISION HEROS
			if(heros.getRectangle().intersects(this.rec)){
				heros.decVie();

			}

			/////////////////////////////////////////
			// COLLISION FIREBALL
			rec = new Rectangle(x,y,8,8);
			if(heros.getFireball() != null){
				collision(heros.getFireball());
			}
		}
	}

	public void collision(Fireball fire){		
		if(fire.isAlive() && fire.getRectangle().intersects(rec)){
			this.detruire();
			fire.detruire();
		}
	}

	public void detruire(){
		this.alive = false;
		
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}


	public static void initRessources() throws SlickException{
		sp = new SpriteSheet("res/sprites/slimeBall.png",8,8);
	}
	
	public boolean finAnimation(){
		return (alive);
	}

}
