package Ennemi;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

import game.Fireball;
import game.Game;
import game.Heros;

public class SlimeBleu implements Ennemi{

	public static SpriteSheet sp;
	private int hp;
	private boolean alive;
	private String direction;
	private int x,y;
	private Rectangle rec;
	private int cptAnimation = 39, cptAnimationMort,cptFuite;
	public static int NB = 0;
	
	public SlimeBleu(String coordonnees){
		this.x = Integer.parseInt(coordonnees.split("-")[0])*32;
		this.y = Integer.parseInt(coordonnees.split("-")[1])*32;
		rec = new Rectangle(x,y+5,24,16);
		alive = true;
		NB++;
	}
	
	public boolean isAlive() {
		if(alive==true){
			return true;
			//code a faire
		}else{
			return false;
		}
	}
	
	public void render() {	
		if(alive){
			int caseX;
			if(cptAnimation>=30){
				caseX = 3;
			}else if(cptAnimation>=20){
				caseX = 2;
			}else if(cptAnimation>=10){
				caseX = 1;
			}else if(cptAnimation>0){
				caseX=1;
			}else{
				caseX=1;
				cptAnimation=39;
			}
			cptAnimation--;
			sp.getSprite(caseX, 0).draw(x,y);
			if(Game.DEBUG_HITBOX)Game.graphics.draw(rec);
		}else{
			int caseX;
			if(cptAnimationMort>=30){
				caseX = 0;
			}else if(cptAnimationMort>=20){
				caseX = 1;
			}else if(cptAnimationMort>=10){
				caseX = 2;
			}else if(cptAnimationMort>0){
				caseX=3;
			}else{
				caseX=4;
				
			}
			cptAnimationMort--;
			sp.getSprite(caseX, 1).draw(x,y);
		}
		
	}

	public void update(Heros heros) {
		if(alive){
			
			////////////////////////////////////////
			// DEPLACEMENT
			int xdirection,ydirection;
			
			if(heros.getX()+40<this.getX()+12){
				xdirection = -1;
			}else if(heros.getX()+20>this.getX()+12){
				xdirection = 1;
			}else{
				xdirection = 0;
			}
			
			if(heros.getY()+40<this.getY()+12){
				ydirection = -1;
			}else if(heros.getY()+20>this.getY()+12){
				ydirection = 1;
			}else{
				ydirection = 0;
			}
			
			if(this.cptFuite>0){
				xdirection *=-1;
				ydirection *=-1;
				cptFuite--;
			}
				if(Math.random()<0.3){
					if(Math.random()<0.7){
						if(Math.random()<0.5){
							if(!Game.getMapCourante().isBlocked(x+12+14*xdirection, y+12,false,false)){
								this.x+=2*xdirection;
							}
							if(!Game.getMapCourante().isBlocked(x+12, y+12+14*ydirection,false,false)){
								this.y+=2*ydirection;
							}
							
						}else{
							if(!Game.getMapCourante().isBlocked(x+12+14*xdirection, y+12,false,false)){
								this.x+=3*xdirection;
							}
							if(!Game.getMapCourante().isBlocked(x+12, y+12+14*ydirection,false,false)){
								this.y+=3*ydirection;
							}
						}
					}else{
						if(!Game.getMapCourante().isBlocked(x+12+14*xdirection, y+12,false,false)){
							this.x+=1*xdirection;
						}
						if(!Game.getMapCourante().isBlocked(x+12, y+12+14*ydirection,false,false)){
							this.y+=1*ydirection;
						}
					}
				}
				
				////////////////////////////////////////
				// COLLISION HEROS
				if(heros.getRectangle().intersects(this.rec)){
					heros.decVie();
					this.cptFuite=150;
				}
				
				/////////////////////////////////////////
				// COLLISION FIREBALL
				rec = new Rectangle(x,y+5,24,16);
				if(heros.getFireball() != null){
					collision(heros.getFireball());
				}
			}
			
		
	}
	
	public void collision(Fireball fire){		
		if(fire.isAlive() && fire.getRectangle().intersects(rec)){
			this.detruire();
			fire.detruire();
		}
	}
	
	public void detruire(){
		this.alive = false;
		Heros.COMPTEUR_BLEU++;
		this.cptAnimationMort = 39;
	}
	
	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	

	public static void initRessources() throws SlickException{
		sp = new SpriteSheet("res/sprites/slimeBleu.png",24,24);
	}

	public boolean finAnimation(){
		if(alive)
			return false;
		else{
			return (cptAnimationMort <=0);
		}
	}
}
