package Events;

import java.awt.Color;

import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;

import game.AnimationTransformation;
import game.Game;
import game.Heros;
import game.Ressources;

public class DebloqueAir implements Event{
	
	private Heros heros;
	private boolean finish = false;
	private static DebloqueAir instance;
	private static Sound powerup;
	
	private int etat;
	private int cptTempo = 0;
	
	private DebloqueAir(Heros heros){
		this.heros = heros;
		this.finish = false;
		etat = 0;
		
	}
	
	
	public void render(){
		if(etat==1 || etat==2){
			Ressources.getInstance().dialbox.draw(96,320);
			Game.font.drawString(110, 330, "The Great God gives you the power of wind !");	
		}else if(etat==4 || etat==5){
			Ressources.getInstance().dialbox.draw(96,320);
			Game.font.drawString(110, 330, "Now you are able to fly !");	
		}else if(etat==6|| etat ==7){
			Ressources.getInstance().dialbox.draw(96,320);
			Game.font.drawString(110, 330, "Fly away, your family is waiting for you...");	
		}
	}
	public void play(){
		
		if(etat==0){
			//initialisation de l'evenement
			heros.bloquerMouvement();
			heros.setDirection("BAS");
			etat = 1;
			Game.pause(1);
		}else if(etat==1){
			if(heros.getInput().isKeyDown(Input.KEY_SPACE)){
				etat = 2;
			}
		}else if(etat==2){
			if(!heros.getInput().isKeyDown(Input.KEY_SPACE)){
				heros.animationTransformation = new AnimationTransformation(heros.getX()+16, heros.getY()+16,4);
				Ressources.getInstance().selec.play();
				heros.PEUT_VOLER = true;
				powerup.play();
				etat=3;
			}
		}else if(etat==3){
			Game.pause(1);
			etat=4;
		}else if(etat==4){
			if(heros.getInput().isKeyDown(Input.KEY_SPACE)){
				etat = 5;
			}
		}else if(etat==5){
			if(!heros.getInput().isKeyDown(Input.KEY_SPACE)){
				Ressources.getInstance().selec.play();
				etat = 6;
			}
		}else if(etat==6){
			if(heros.getInput().isKeyDown(Input.KEY_SPACE)){
				etat = 7;
			}
		}else if(etat==7){
			if(!heros.getInput().isKeyDown(Input.KEY_SPACE)){
				Ressources.getInstance().selec.play();
				etat = 8;
			}
		}else if(etat==8){
			//heros s'envole
			if(heros.getY()==-70){
				etat=99;
				System.out.println("FIN");
			}else{
				if(cptTempo==0 || cptTempo==1){
					heros.setY(heros.getY()-1);
					cptTempo++;
				}else{
					cptTempo=0;
				}
				
			}
		}else if(etat==99){
			//fin de l'evenement
			Game.FIN_DU_JEU = 1;
			heros.debloquerMouvement();
			this.finish = true;
			Game.pause(1);
		}
		
	}
	
	public boolean isFinish(){
		return finish;
	}
	
	public static DebloqueAir getInstance(){
		return instance;
	}
	
	public static void initInstance(Heros heros) throws SlickException{
		instance = new DebloqueAir(heros);
		powerup = new Sound("res/sound/powerup1.wav");
	}
}
