package Events;

import java.awt.Color;

import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;

import game.AnimationTransformation;
import game.Game;
import game.Heros;
import game.Ressources;

public class DebloqueTerre implements Event{
	
	private Heros heros;
	private boolean finish = false;
	private static DebloqueTerre instance;
	private static Sound powerup;
	
	private int etat;

	
	private DebloqueTerre(Heros heros){
		this.heros = heros;
		this.finish = false;
		etat = 0;
		
	}
	
	
	public void render(){
		if(etat==1 || etat==2){
			Ressources.getInstance().dialbox.draw(96,250);
			Game.font.drawString(110, 258, "The Great God gives you the power of earth !");	
		}else if(etat==4){
			Ressources.getInstance().dialbox.draw(96,250);
			Game.font.drawString(110, 258, "Now you are able to climb mountains");	
		}
	}
	public void play(){
		
		if(etat==0){
			//initialisation de l'evenement
			heros.bloquerMouvement();
			heros.setDirection("BAS");
			etat = 1;
			Game.pause(1);
		}else if(etat==1){
			if(heros.getInput().isKeyDown(Input.KEY_SPACE)){
				etat = 2;
			}
		}else if(etat==2){
			if(!heros.getInput().isKeyDown(Input.KEY_SPACE)){
				heros.animationTransformation = new AnimationTransformation(heros.getX()+16, heros.getY()+16,3);
				Ressources.getInstance().selec.play();
				heros.PEUT_GRIMPER = true;
				powerup.play();
				etat=3;
			}
		}else if(etat==3){
			Game.pause(1);
			etat=4;
		}else if(etat==4){
			if(heros.getInput().isKeyDown(Input.KEY_SPACE)){
				etat = 5;
			}
		}else if(etat==5){
			if(!heros.getInput().isKeyDown(Input.KEY_SPACE)){
				Ressources.getInstance().selec.play();
				etat = 99;
			}
		}else if(etat==99){
			//fin de l'evenement
			heros.debloquerMouvement();
			this.finish = true;
			Game.pause(1);
		}
		
	}
	
	public boolean isFinish(){
		return finish;
	}
	
	public static DebloqueTerre getInstance(){
		return instance;
	}
	
	public static void initInstance(Heros heros) throws SlickException{
		instance = new DebloqueTerre(heros);
		powerup = new Sound("res/sound/powerup1.wav");
	}
}
