package ItemMap;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.SpriteSheet;

import game.Heros;

public class AnimationEau implements ItemMap{

	private static SpriteSheet sp;
	private int x,y;
	private boolean alive;
	private int cptAnimation;
	private static Sound sonEau;
	
	public AnimationEau(int x, int y){
		this.x = x;
		this.y = y;
		alive = true;
		cptAnimation = 40;
		sonEau.play();		
	}

	public void render() {
		if(cptAnimation>0){
			if(cptAnimation>30){
				sp.getSprite(0, 0).draw(x,y);
			}else if(cptAnimation>20){
				sp.getSprite(1, 0).draw(x,y);
			}else if(cptAnimation>10){
				sp.getSprite(2, 0).draw(x,y);
			}else{
				sp.getSprite(3, 0).draw(x,y);
			}
			cptAnimation--;
		}
		
	}
	
	public int getX() {	
		return x;
	}

	public int getY() {
		return y;
	}

	
	public boolean isDestroy() {
		return !alive || cptAnimation==0;
	}

	
	public boolean block(){
		return false;
	}
	
	public void update(Heros heros) {
		
	}

	public static void initRessources() throws SlickException{
		sp = new SpriteSheet("res/sprites/rond_eau.png",24,20);
		sonEau = new Sound("res/sound/water1.wav");
	}
}
