package ItemMap;

import game.Fireball;
import game.Heros;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

public class Coffre implements ItemMap {

	private int x;
	private int y;
	private Rectangle rec;
	
	private boolean detruit = false, viePrise = false;
	private static SpriteSheet sp; 
	
	
	public Coffre(String coordonnees){
		this.x = Integer.parseInt(coordonnees.split("-")[0])*32;
		this.y = Integer.parseInt(coordonnees.split("-")[1])*32;
		rec = new Rectangle(x,y,32,32);
	}
	
	public void render(){
		if(detruit){
			if(!viePrise){
				sp.getSprite(1,0).draw(x,y);
			}
		}else{
			sp.getSprite(0, 0).draw(x,y);
		}
	}
	
	public void update(Heros heros){
		if(!detruit){
			if(heros.getFireball() != null){
				collision(heros.getFireball());
			}
		}else if(!viePrise){
			if(heros.getRectangle().intersects(rec)){
				heros.incVie();
				this.viePrise = true;
			}
		}
		
	}
	public void collision(Fireball fire){		
		if(!detruit && fire.isAlive() && fire.getRectangle().intersects(rec)){
			this.detruit = true;
			fire.detruire();
		}
	}

	public boolean isDestroy(){
		return detruit && viePrise;
	}
	
	public boolean block(){
		return !(detruit);
	}
	
	public int getX(){
		return x/32;
	}
	public int getY(){
		return y/32;
	}
	
	public static void initRessource() throws SlickException{
		sp = new SpriteSheet("res/sprites/coffre.png",32,32);
	}
}
