package ItemMap;

import game.Fireball;
import game.Heros;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

public class Panneau implements ItemMap {

	private int x;
	private int y;
	private Rectangle rec;
	
	private boolean detruit = false;
	private static SpriteSheet sp; 
	
	
	public Panneau(String coordonnees){
		this.x = Integer.parseInt(coordonnees.split("-")[0])*32;
		this.y = Integer.parseInt(coordonnees.split("-")[1])*32;
		rec = new Rectangle(x,y,32,32);
	}
	
	public void render(){
		if(detruit){
			sp.getSprite(1,0).draw(x,y);
		}else{
			sp.getSprite(0, 0).draw(x,y);
		}
	}
	
	public void update(Heros heros){
		if(heros.getFireball() != null){
			collision(heros.getFireball());
		}
	}
	public void collision(Fireball fire){		
		if(!detruit && fire.isAlive() && fire.getRectangle().intersects(rec)){
			this.detruit = true;
			fire.detruire();
		}
	}

	public boolean isDestroy(){
		return detruit;
	}
	
	public int getX(){
		return x/32;
	}
	public int getY(){
		return y/32;
	}
	
	public boolean block(){
		return true;
	}
	
	public static void initPanneau() throws SlickException{
		sp = new SpriteSheet("res/sprites/panneau.png",32,32);
	}
}
