package game;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

public class Fireball {

	private static  SpriteSheet sp,sp2;
	private int x,y,cpt;
	private String direction;
	private boolean alive;
	private Rectangle rec;
	private int cptAnimation,cptAnimationMort=-1;
	public Fireball(int x,int y,int cpt,String direction){
		this.x = x-8;
		this.y = y-8;
		this.direction = direction;
		this.cpt = cpt + 24;
		this.alive = true;
		rec = new Rectangle(x, y, 16, 16);
		cptAnimation = 40;
		cptAnimationMort = -1;
	}
	
	public void render(){
		int caseX=3;
		if(alive){
			if(cptAnimation>=30){
				caseX = 3;
			}else if(cptAnimation>=20){
				caseX = 2;
			}else if(cptAnimation>=10){
				caseX = 1;
			}else if(cptAnimation>0){
				caseX=1;
			}else{
				caseX=1;
				cptAnimation=39;
			}
			cptAnimation--;
			sp.getSprite(caseX, 0).draw(x,y);
			if(Game.DEBUG_HITBOX)Game.graphics.draw(rec);
			
		}else if(cptAnimationMort>0){
			if(cptAnimationMort>=30){
				caseX = 0;
			}else if(cptAnimationMort>=20){
				caseX = 1;
			}else if(cptAnimationMort>=10){
				caseX = 2;
			}else{
				caseX=3;
			}
			cptAnimationMort--;
			sp2.getSprite(caseX, 0).draw(x,y);
		}
	}
	public void update(){
		if(isAlive()){
			if(direction=="HAUT"){
				this.y-=3;
			}else if(direction=="BAS"){
				this.y+=3;
			}else if(direction=="GAUCHE"){
				this.x-=3;
			}else if(direction=="DROITE"){
				this.x+=3;
			}
			cpt--;
			if(Game.getMapCourante().isBlocked(x+8, y+8,true,false)){
				alive = false;
				if(cptAnimationMort==-1)cptAnimationMort = 49;
			}
			rec = new Rectangle(x, y, 16, 16);
		}
	}
	
	public Rectangle getRectangle(){
		return rec;
	}
	
	public boolean  isAlive(){
		if(!alive){
			return false;
		}else{
			if(cpt<=0){
				alive = false;
				if(cptAnimationMort==-1)cptAnimationMort = 49;
				return false;
			}else{
				if(this.x > -16 && this.x+16 < 640 && this.y >-16 && this.y+16<480){
					return true;
				}else{
					alive = false;
					if(cptAnimationMort==-1)cptAnimationMort = 49;
					return false;
				}
			}
		}
	}
	
	public void detruire(){
		cptAnimationMort = 49;
		alive = false;
	}
	
	//initialise l'image
	public static void   initRessources() throws SlickException{
		sp = new SpriteSheet("res/sprites/fireball.png",16,16);
		sp2 = new SpriteSheet("res/sprites/fireball2.png",16,16);
	}
}
