package game;


import org.newdawn.slick.Color;
import org.newdawn.slick.Font;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

import Ennemi.SlimeBall;
import Ennemi.SlimeBleu;
import Ennemi.SlimeJaune;
import Ennemi.SlimeRouge;
import Ennemi.SlimeViolet;
import Events.DebloqueAir;
import Events.DebloqueEau;
import Events.DebloqueFeu;
import Events.DebloqueTerre;
import Events.Event;
import ItemMap.AnimationEau;
import ItemMap.Coffre;
import ItemMap.CoffreDiamant;
import ItemMap.Panneau;


/**
 ** C'est l'état principal du jeu, c'est ici que l'on codera l'action du jeu !
 */
public class Game extends BasicGameState
{
	public static final int ID = 1;
	public static final boolean DEBUG = false;
	public static final boolean DEBUG_MAP = false;
	public static final boolean DEBUG_HITBOX = false;
	public static Map[][] maps = new Map[4][6];
	private static Map mapCourante;
	public static Event event;
	public static Font font;
	public static Graphics graphics;
	private static int xCourant,yCourant;
	public static int cptPause = 0;
	public static Music music;
	
	private static Heros heros;
	private Hud hud;
	public int getID() {
		return ID;
	}
	public static int FIN_DU_JEU = 0;
	
	//boucle d'initialisation
	public void init(GameContainer container, StateBasedGame game) throws SlickException {
		Fireball.initRessources();
		Hud.initRessources();
		Ressources.initRessources();
		
		music = new Music();
		maps[0][1] = new Map(0,1);
		
		maps[1][0] = new Map(1,0);
		maps[2][0] = new Map(2,0);
		maps[3][0] = new Map(3,0);
		
		maps[1][1] = new Map(1,1);
		maps[1][2] = new Map(1,2);
		maps[1][3] = new Map(1,3);
		maps[1][4] = new Map(1,4);
		maps[1][5] = new Map(1,5);
		
		maps[2][1] = new Map(2,1);
		maps[2][2] = new Map(2,2);
		maps[2][3] = new Map(2,3);
		maps[2][4] = new Map(2,4);
		maps[2][5] = new Map(2,5);
		
		maps[3][1] = new Map(3,1);
		maps[3][2] = new Map(3,2);
		maps[3][3] = new Map(3,3);
		maps[3][4] = new Map(3,4);
		maps[3][5] = new Map(3,5);
		xCourant = 2;
		yCourant = 3;
		heros = new Heros();
		hud = new Hud(heros);
		
		//initialisation des events
		DebloqueFeu.initInstance(heros);
		DebloqueEau.initInstance(heros);
		DebloqueTerre.initInstance(heros);
		DebloqueAir.initInstance(heros);
		Panneau.initPanneau();
		SlimeBleu.initRessources();
		SlimeJaune.initRessources();
		SlimeRouge.initRessources();
		SlimeViolet.initRessources();
		SlimeBall.initRessources();
		AnimationEau.initRessources();
		Coffre.initRessource();
		CoffreDiamant.initRessource();
		AnimationTransformation.initRessources();
		
		
		music.start();
	}

	//boucle d'affichage
	public void render(GameContainer container, StateBasedGame game, Graphics g) throws SlickException {
		if(font==null){
			font = g.getFont();
			graphics = g;
		}
		getMapCourante().renderBot();
		heros.render();
		getMapCourante().renderTop();
		if(DEBUG_MAP)getMapCourante().renderObject();
		if(DEBUG)g.drawString("Coor "+heros.getX()+" - "+heros.getY(), 2, 2);
		if(DEBUG)g.drawString("Map  "+getMapCourante().getX()+" - "+getMapCourante().getY(),2,22);
		
		if(event != null && !event.isFinish()){
			event.render();
		}
		hud.render();
		
	}

	//boucle d'update
	public void update(GameContainer container, StateBasedGame game, int delta) throws SlickException {
		if(cptPause>0){
			cptPause--;
		}else if(FIN_DU_JEU==0 && heros.getVie()>0){
			heros.update(getMapCourante());
			if(event != null && !event.isFinish()){
				event.play();
			}
			Game.getMapCourante().update(heros);
		}else if( heros.getVie()<=0){
				Map.stopMusique();
				game.enterState(2);
    			game.enterState(2, new FadeOutTransition (Color.black, 6000), new FadeInTransition (Color.black, 1000));
    			this.init(container, game);
    			this.inputEnded();
		}else{
			if(FIN_DU_JEU < 255){
				FIN_DU_JEU++;
			}
			if(FIN_DU_JEU < 255){
				FIN_DU_JEU++;
			}
		}
		
	}
	
	public static void pause(int cpt){
		cptPause = cpt*90;
	}
	
	public static void setMapCourante(int x,int y){
		xCourant = x;
		yCourant = y;
		getMapCourante().jouerMusique();
	}
	
	public static void teleport(int mapX, int mapY, int herosX, int herosY){
		heros.setX((herosX*32)-16);
		heros.setY((herosY*32)-16);
		xCourant = mapX;
		yCourant = mapY;
		getMapCourante().jouerMusique();
	}
	
	public static Map getMapCourante(){
		return maps[xCourant][yCourant];
	}
}