package game;

import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

public class Heros {
	
	private SpriteSheet spPhase1,spPhase2,spPhase3,spPhase4,spPhase5;
	private int x,y,dy;
	private boolean bGauche,bDroit,bHaut,bBas;
	private String direction;
	private int cptAnimation = 0;
	private int cptBouleDeFeu = 0;
	private int cptVie = 0,cptMarche;
	private Input input;
	private Fireball fireball;
	private Rectangle rec;
	public AnimationTransformation animationTransformation;
	
	private boolean peutBouger = true;
	
	private int VIE = 3 ;
	public boolean PEUT_TIRER_FEU = false; //FALSE EN PROD
	public boolean PEUT_MARCHER_EAU = false; //FALSE EN PROD
	public boolean PEUT_GRIMPER = false; //FALSE EN PROD
	public boolean PEUT_VOLER = false; //FALSE EN PROD
	
	public static int COMPTEUR_DIAMANT = 0;
	public static int COMPTEUR_ROUGE = 0;
	public static int COMPTEUR_BLEU = 0;
	public static int COMPTEUR_JAUNE = 0;
	public static int COMPTEUR_VIOLET = 0;
	public static int COMPTEUR_DEGATS = 0;
	
	private Sound shoot1,shoot2,shoot3,hurt1,soin1,defaut;
	private Sound sonGameOver;
	
	public Heros() throws SlickException{
		
		//initialisation des sprites;
		spPhase1 = new SpriteSheet("res/heros/f1_walk.png",64,64);
		spPhase2 = new SpriteSheet("res/heros/f2_walk.png",64,64);
		spPhase3 = new SpriteSheet("res/heros/f3_walk.png",64,64);
		spPhase4 = new SpriteSheet("res/heros/f4_walk.png",64,64);
		spPhase5 = new SpriteSheet("res/heros/f5_walk.png",64,64);
		
		shoot1 = new Sound("res/sound/shoot1.wav");
		shoot2 = new Sound("res/sound/shoot2.wav");
		shoot3 = new Sound("res/sound/shoot3.wav");
		hurt1 = new Sound("res/sound/hurt1.wav");
		soin1 = new Sound("res/sound/soin.wav");
		defaut = new Sound("res/sound/default.wav");
		sonGameOver = new Sound("res/sound/gameover.wav");
		
		//initialisation position
		x = 288;
		y = 208;
		direction = "BAS";
		
		
		//initialisation touche
		input = new Input(0);
		rec = new Rectangle(x+20,y+20,24,24);
	}
	
	public void render(){
		int caseX = 0;
		int caseY = 0;
		
		if(Game.getMapCourante().isEscalade(x+32, y+42)){
			caseY = 2;
		}else if(direction=="HAUT"){
			caseY = 2;
		}else if(direction=="GAUCHE"){
			caseY = 3;
		}else if(direction=="DROITE"){
			caseY = 1;
		}else{
			caseY = 0;
		}
		if(!bBas && !bHaut && !bGauche && !bDroit){
			caseX = 1;
			cptAnimation = 0;
		}else{
			caseX = cptAnimation/10;
			cptAnimation--;
			if(cptAnimation<0){
				cptAnimation= 10*3 -1;
			}
		}
		
		if(Game.getMapCourante().isSurEau(x+32, y+42)){
			dy = 4;
		}else{
			dy = 0;
		}
		
		if(this.PEUT_MARCHER_EAU && this.PEUT_TIRER_FEU && this.PEUT_GRIMPER && this.PEUT_VOLER){
			spPhase5.getSprite(caseX, caseY).draw(x,y+dy);
		}else if(this.PEUT_MARCHER_EAU && this.PEUT_TIRER_FEU && this.PEUT_GRIMPER){
			spPhase4.getSprite(caseX, caseY).draw(x,y+dy);
		}else if(this.PEUT_MARCHER_EAU && this.PEUT_TIRER_FEU){
			spPhase3.getSprite(caseX, caseY).draw(x,y+dy);
		}else if(this.PEUT_TIRER_FEU){
			spPhase2.getSprite(caseX, caseY).draw(x,y+dy);
		}else{
			spPhase1.getSprite(caseX, caseY).draw(x,y+dy);
		}
		
		if(fireball != null){
			fireball.render();
		}
		
		if(animationTransformation != null && !animationTransformation.isDestroy())animationTransformation.render();
		if(Game.DEBUG_HITBOX)Game.graphics.draw(rec);
		
	}
	
	
	
	public void update(Map mapCourante){
		if(cptVie>0){
			cptVie--;
		}
		bHaut = false;
		bBas = false;
		bGauche = false;
		bDroit = false;
		
		rec.setX(x+21);
		rec.setY(y+20);
		
		if(peutBouger){
			mapCourante.isEvent(x+38, y+32);
			
			if(input.isKeyDown(Input.KEY_UP)){
				bHaut = true;
				direction = "HAUT";
				deplacement();
			}else if(input.isKeyDown(Input.KEY_DOWN)){
				bBas = true;
				direction = "BAS";
				deplacement();
			}else if(input.isKeyDown(Input.KEY_LEFT)){
				bGauche = true;
				direction = "GAUCHE";
				deplacement();
			}else if(input.isKeyDown(Input.KEY_RIGHT)){
				bDroit = true;
				direction = "DROITE";
				deplacement();
			}
			
			if(PEUT_TIRER_FEU){
				if(input.isKeyDown(Input.KEY_SPACE)){
					if(cptBouleDeFeu<120){
						cptBouleDeFeu++;
					}
				}else{
					if(cptBouleDeFeu>2){
						if(fireball == null || !fireball.isAlive()){
							if(cptBouleDeFeu<50){
								shoot1.play();
							}else if(cptBouleDeFeu<110){
								shoot2.play();
							}else{
								shoot3.play();
							}
							fireball = new Fireball(x+32,y+36,cptBouleDeFeu,direction);
							cptBouleDeFeu = 0;
						}
					}
				}
		}
		
		}
		if(animationTransformation != null && !animationTransformation.isDestroy())animationTransformation.update(this);
		if(fireball != null && fireball.isAlive()){
			fireball.update();
		}
	}
	
	private void deplacement(){

		
		if(bHaut && direction=="HAUT"){
			if(!Game.getMapCourante().isBlocked(x+32, y+34,PEUT_MARCHER_EAU,PEUT_GRIMPER)){
				if(cptMarche==0 || cptMarche==1)y-=1;
				if(!Game.getMapCourante().isEscalier(x+32,y+44) || (cptMarche==2 && !Game.getMapCourante().isEscalade(x+32,y+44)) ){
						y-=1;
				}
			}
		}else if(bBas && direction=="BAS"){
			if(!Game.getMapCourante().isBlocked(x+32, y+51,PEUT_MARCHER_EAU,PEUT_GRIMPER)){
				if(cptMarche==0 || cptMarche==1)y+=1;
				if(!Game.getMapCourante().isEscalier(x+32,y+44)|| (cptMarche==2 && !Game.getMapCourante().isEscalade(x+32,y+44))){
						y+=1;
				}
			}
		}else if(bGauche && direction=="GAUCHE"){
			if(!Game.getMapCourante().isBlocked(x+24, y+48,PEUT_MARCHER_EAU,PEUT_GRIMPER) && !Game.getMapCourante().isBlocked(x+24, y+38,PEUT_MARCHER_EAU,PEUT_GRIMPER)){
				if(cptMarche==0|| cptMarche==1)x-=1;
				if(!Game.getMapCourante().isEscalier(x+32,y+44)|| (cptMarche==2 && !Game.getMapCourante().isEscalade(x+32,y+44)) ){
						x-=1;
				}
			}
		}else if(bDroit && direction=="DROITE"){
			if(!Game.getMapCourante().isBlocked(x+40, y+48,PEUT_MARCHER_EAU,PEUT_GRIMPER) && !Game.getMapCourante().isBlocked(x+40, y+38,PEUT_MARCHER_EAU,PEUT_GRIMPER)  ){
				if(cptMarche==0 || cptMarche==1)x+=1;
				if(!Game.getMapCourante().isEscalier(x+32,y+44)|| (cptMarche==2 && !Game.getMapCourante().isEscalade(x+32,y+44)) ){
						x+=1;
				}
			}
		}
		
		if(cptMarche>2){
			cptMarche = 0;
		}else{
			cptMarche++;
		}
		if(y>428){
			y=-18;
			Game.setMapCourante(Game.getMapCourante().getX(),Game.getMapCourante().getY()+1);
		}else if(y<-20){
			y=429;
			Game.setMapCourante(Game.getMapCourante().getX(),Game.getMapCourante().getY()-1);
			
		}else if(x>594){
			x = -10;
			Game.setMapCourante(Game.getMapCourante().getX()+1,Game.getMapCourante().getY());
		}else if(x<-12){
			x = 593;
			Game.setMapCourante(Game.getMapCourante().getX()-1,Game.getMapCourante().getY());
		}
		
	}//FIN UPDATE
	
	public void bloquerMouvement(){
		peutBouger = false;
	}
	
	public void debloquerMouvement(){
		peutBouger = true;
	}
	
	/////////////////////////////////////////
	// getters et setters
	
	//touches clavier
	public boolean isBGauche(){
		return bGauche;
	}
	public boolean isBDroit(){
		return bDroit;
	}
	public boolean isBHaut(){
		return bHaut;
	}
	public boolean isBBas(){
		return bBas;
	}
	
	//position
	public int getX(){
		return x;
	}
	public int getY(){
		return y;
	}
	public void setX(int x){
		this.x = x;
	}
	public void setY(int y){
		this.y = y;
	}
	public String getDirection(){
		return direction;
	}
	public void setDirection(String d){
		this.direction = d;
	}
	public Rectangle getRectangle(){
		return rec;
	}
	
	
	//input
	public Input getInput(){
		return input;
	}
	
	//fireball
	public int getCptBouleDeFeu(){
		return cptBouleDeFeu;
	}
	public Fireball getFireball(){
		return fireball;
	}
	
	//vie
	public int getVie(){
		return VIE;
	}
	public void decVie(){
		if(cptVie==0){
			VIE-=1;
			hurt1.play();
			if(VIE==0){
				sonGameOver.play();
			}
			cptVie = 100;
			this.COMPTEUR_DEGATS++;
		}
		
	}
	public int getCptVie(){
		return cptVie;
	}
	public void incVie(){
		if(VIE<3){
			soin1.play();
			VIE++;
		}else{
			defaut.play();
		}
	}
	
}
