package game;

import org.newdawn.slick.Color;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;

import Ennemi.SlimeBleu;
import Ennemi.SlimeJaune;
import Ennemi.SlimeRouge;
import Ennemi.SlimeViolet;

public class Hud {

	private static Image fireball01,fireball01_02,fireball02;
	private static Image viePleine,vieVide;
	private static Image diamant;
	private static Image fog;
	private static Image finJeu;
	private static Image imgGameOver;
	
	private Heros heros;
	private Rectangle rec,rec2,rec3;
	
	public Hud(Heros heros){
		this.heros = heros;
		rec = new Rectangle(0,0,640,480);
		rec2 = new Rectangle(0,0,72,26);
		rec3 = new Rectangle(592,0,48,26);
	}
	
	public void render(){
		
		
			if(Game.getMapCourante().isFog()){
				fog.draw(-640+heros.getX()+32,-480+heros.getY()+32);
			}
		
			if(heros.getCptVie()>0){
				Color c = new Color(255,0,0,heros.getCptVie());
				Game.graphics.setColor(c);
				Game.graphics.fill(rec);
				
			}
			
			Game.graphics.setColor(new Color(0,0,0,70));
			Game.graphics.fill(rec2);
			Game.graphics.fill(rec3);
			//affichage nombre diamants
			Game.graphics.setColor(new Color(255,255,255));
			diamant.draw(600,4);
			Game.graphics.drawString(heros.COMPTEUR_DIAMANT+"", 618, 4);
			
			//affichage de la vie
			if(heros.getVie()>=1){
				viePleine.draw(5,5);
				if(heros.getVie()>=2){
					viePleine.draw(25,5);
					if(heros.getVie()>=3){
						viePleine.draw(45,5);
					}else{
						vieVide.draw(45,5);
					}
				}else{
					vieVide.draw(25,5);
					vieVide.draw(45,5);
				}
			}else{
				vieVide.draw(5,5);
				vieVide.draw(25,5);
				vieVide.draw(45,5);
			}
			
			if(heros.PEUT_TIRER_FEU){
				//affichage des fireball
				if(heros.getCptBouleDeFeu()<120){
					fireball01.draw(0, 460);
				}else{
					fireball01_02.draw(0, 460);
				}
				
				if(heros.getCptBouleDeFeu()>0){
					fireball02.draw(3, 460,heros.getCptBouleDeFeu() -1, 20);
				}
			}
			
			if(Game.FIN_DU_JEU>0 && Game.FIN_DU_JEU<255){
			
				Game.graphics.setColor(new Color(255,255,255,Game.FIN_DU_JEU));
				Game.graphics.fill(rec);
			}else if(Game.FIN_DU_JEU>254){
				finJeu.draw();
				Game.graphics.drawString(heros.COMPTEUR_DIAMANT+" / 10", 70, 430);
				Game.graphics.drawString(heros.COMPTEUR_VIOLET+" / "+SlimeViolet.NB, 70, 302);
				Game.graphics.drawString(heros.COMPTEUR_ROUGE+" / "+SlimeRouge.NB, 70, 270);
				Game.graphics.drawString(heros.COMPTEUR_JAUNE+" / "+SlimeJaune.NB, 70, 334);
				Game.graphics.drawString(heros.COMPTEUR_BLEU+" / "+SlimeBleu.NB, 70, 368);
				
				int score = heros.COMPTEUR_DIAMANT*10 + heros.COMPTEUR_BLEU*4 + heros.COMPTEUR_VIOLET*3 + heros.COMPTEUR_JAUNE+heros.COMPTEUR_ROUGE*2-heros.COMPTEUR_DEGATS*9;
				Game.graphics.drawString("SCORE : "+score, 524, 426);
				
			}
			
//			if(heros.getCptVie()<=0){
//				imgGameOver.draw(0,0);
//			}
//		
	}
	
	//initialise l'image
	public static void initRessources() throws SlickException{
		fireball01 = new Image("res/hud/fireball01.png");
		fireball01_02 = new Image("res/hud/fireball01-02.png");
		fireball02 = new Image("res/hud/fireball02.png");
		viePleine = new Image("res/hud/viePleine.png");
		vieVide = new Image("res/hud/vieVide.png");
		diamant = new Image("res/hud/diamant.png");
		fog = new Image("res/hud/fog.png");
		finJeu = new Image("res/hud/end.png");
		imgGameOver = new Image("res/hud/gameover.png");
	}
}
