package game;


import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.GameState;
import org.newdawn.slick.state.StateBasedGame;

public class Launch extends StateBasedGame
{
	private GameState game, title, intro; 
	private AppGameContainer container; // le conteneur du jeu
	private static String[] refIcones ={"res/icones/mini_icone.png","res/icones/grand_icone.png"};
	public Launch() {
		super("Pasazh - Jeremy Lebrun");
	}
	
	
	public void initStatesList(GameContainer container) throws SlickException 
	{
		if (container instanceof AppGameContainer) {
			this.container = (AppGameContainer) container;
		}
		game = new Game();
		title = new TitleScreen();
		intro = new Introduction();
		container.setShowFPS(false);
		
		
		addState(title);
		addState(game);
		addState(intro);
		
	}
	
	public static void main(String[] args) 
	{
		try
		{
			AppGameContainer container = new AppGameContainer(new Launch());
			container.setIcons(refIcones);
			container.setDisplayMode(640, 480, false);
			container.setTargetFrameRate(90);
			container.start();
		}                       
		catch (SlickException e) {
			e.printStackTrace();
		}  
	}
}  // fin de classe