package game;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Music;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.tiled.TiledMap;

import Ennemi.Ennemi;
import Ennemi.SlimeBleu;
import Ennemi.SlimeJaune;
import Ennemi.SlimeRouge;
import Ennemi.SlimeViolet;
import Events.DebloqueAir;
import Events.DebloqueEau;
import Events.DebloqueFeu;
import Events.DebloqueTerre;
import ItemMap.AnimationEau;
import ItemMap.Coffre;
import ItemMap.CoffreDiamant;
import ItemMap.ItemMap;
import ItemMap.Panneau;



public class Map {

	protected TiledMap map;
	private int idMapX, idMapY;
	private static final int cEVENT = 4;
	private List<ItemMap> items;
	private List<Ennemi> ennemis, ennemisTemp;
	private int cptEau;
	private boolean fog,back;
	private Image background;
	private static Music m1 = null;
	private static Music m2 = null;
	
	public Map(int x,int y) throws SlickException{
		this.idMapX = x;
		this.idMapY = y;
		items = new ArrayList<ItemMap>();
		ennemis = new ArrayList<Ennemi>();
		ennemisTemp = new ArrayList<Ennemi>();
		cptEau = 0;
		if(m1==null){
			m1 = new Music("res/music/plaine.ogg");
		}
		if(m2==null){
			m2 = new Music("res/music/grotte.ogg");
		}
		
		try {
			map = new TiledMap("res/maps/"+x+"-"+y+".tmx","res/maps");
		} catch (SlickException e) {
			// TODO Auto-generated catch block
			System.out.println("Erreur : map non trouvee");
			e.printStackTrace();
		}
		fog = map.getMapProperty("fog", "non").equals("true");
		back = map.getMapProperty("background", "non").equals("1");
		if(back){
			try {
				background = new Image("res/maps/background.png");
			} catch (SlickException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		remplirItems();
		remplirEnnemis();
	}
	
	public void remplirItems(){
		if(!map.getMapProperty("panneau0", "non").equals("non")){
			Panneau p = new Panneau(map.getMapProperty("panneau0", "non"));
			items.add(p);
		}
		if(!map.getMapProperty("panneau1", "non").equals("non")){
			Panneau p = new Panneau(map.getMapProperty("panneau1", "non"));
			items.add(p);
		}
		
		if(!map.getMapProperty("coffre0", "non").equals("non")){
			Coffre c = new Coffre(map.getMapProperty("coffre0", "non"));
			items.add(c);
		}
		
		if(!map.getMapProperty("coffre1", "non").equals("non")){
			Coffre c = new Coffre(map.getMapProperty("coffre1", "non"));
			items.add(c);
		}
		if(!map.getMapProperty("coffre2", "non").equals("non")){
			Coffre c = new Coffre(map.getMapProperty("coffre2", "non"));
			items.add(c);
		}
		
		if(!map.getMapProperty("coffreDiamant0", "non").equals("non")){
			CoffreDiamant c = new CoffreDiamant(map.getMapProperty("coffreDiamant0", "non"));
			items.add(c);
		}
		
		if(!map.getMapProperty("coffreDiamant1", "non").equals("non")){
			CoffreDiamant c = new CoffreDiamant(map.getMapProperty("coffreDiamant1", "non"));
			items.add(c);
		}
	}
	
	public void remplirEnnemis(){
		if(!map.getMapProperty("slimeBleu0", "non").equals("non")){
			SlimeBleu b = new SlimeBleu(map.getMapProperty("slimeBleu0", "non"));
			ennemis.add(b);
		}
		if(!map.getMapProperty("slimeBleu1", "non").equals("non")){
			SlimeBleu b = new SlimeBleu(map.getMapProperty("slimeBleu1", "non"));
			ennemis.add(b);
		}
		if(!map.getMapProperty("slimeBleu2", "non").equals("non")){
			SlimeBleu b = new SlimeBleu(map.getMapProperty("slimeBleu2", "non"));
			ennemis.add(b);
		}
		if(!map.getMapProperty("slimeBleu3", "non").equals("non")){
			SlimeBleu b = new SlimeBleu(map.getMapProperty("slimeBleu3", "non"));
			ennemis.add(b);
		}
		
		if(!map.getMapProperty("slimeJaune0", "non").equals("non")){
			SlimeJaune j = new SlimeJaune(map.getMapProperty("slimeJaune0", "non"));
			ennemis.add(j);
		}
		
		if(!map.getMapProperty("slimeJaune1", "non").equals("non")){
			SlimeJaune j = new SlimeJaune(map.getMapProperty("slimeJaune1", "non"));
			ennemis.add(j);
		}
		
		if(!map.getMapProperty("slimeRouge0", "non").equals("non")){
			SlimeRouge r = new SlimeRouge(map.getMapProperty("slimeRouge0", "non"));
			ennemis.add(r);
		}
		if(!map.getMapProperty("slimeRouge1", "non").equals("non")){
			SlimeRouge r = new SlimeRouge(map.getMapProperty("slimeRouge1", "non"));
			ennemis.add(r);
		}
		
		if(!map.getMapProperty("slimeViolet0", "non").equals("non")){
			SlimeViolet v = new SlimeViolet(map.getMapProperty("slimeViolet0", "non"));
			ennemis.add(v);
		}
		
		if(!map.getMapProperty("slimeViolet1", "non").equals("non")){
			SlimeViolet v = new SlimeViolet(map.getMapProperty("slimeViolet1", "non"));
			ennemis.add(v);
		}
	}
	
	//draw bot map layers
	public void renderBot(){
		if(back){
			background.draw(0,0);
		}
		map.render(0,0,0,0, map.getWidth(), map.getHeight(), 0, false);
		map.render(0,0,0,0, map.getWidth(), map.getHeight(), 1, false);
		map.render(0,0,0,0, map.getWidth(), map.getHeight(), 2, false);
		for(ItemMap it:items){
			it.render();
		}
		for(Ennemi en:ennemis){
			en.render();
		}
	}
	
	//draw top layer
	public void renderTop(){
		map.render(0,0,0,0, map.getWidth(), map.getHeight(), 3, false);
	}
	
	//debug : draw object layer
	public void renderObject(){
		map.render(0,0,0,0, map.getWidth(), map.getHeight(), cEVENT, false);
	}
	
	public void update(Heros heros){
		//on enleve les ennemis une fois disparu
		Iterator<Ennemi> it2 = ennemis.iterator();
		while(it2.hasNext()){
			Ennemi en = it2.next();
			if(!en.isAlive() && en.finAnimation()){
				it2.remove();
			}
		}
		
		for(ItemMap it:items){
			it.update(heros);
		}
		for(Ennemi en:ennemis){
			en.update(heros);
		}
		
		for(Ennemi en:ennemisTemp){
			ennemis.add(en);
		}
		ennemisTemp.clear();
		
		int idTile = map.getTileId((int)((heros.getX()+32)/32),(int)((heros.getY()+42)/32),cEVENT);
		String blocked = map.getTileProperty(idTile, "block", "non");
		if(blocked.equals("eau") && heros.PEUT_MARCHER_EAU){
			if(cptEau>=45){
				items.add(new AnimationEau(heros.getX()+20,heros.getY()+40));
				cptEau=0;
				Iterator<ItemMap> it = items.iterator();
				while(it.hasNext()){
					ItemMap itm = it.next();
					if(itm.isDestroy()){
						it.remove();
					}
				}
			}else{
				cptEau++;
			}
		}
	}
	//return true si la case aux coordonnees en pixel x-y est une case bloquante
	public boolean isBlocked(int x, int y,boolean marcherSurLeau,boolean escalade){
		if(x>=640 || y>=480 || x<0 || y<0){
			System.out.println("ERROR map-isBlocked  x : "+x+" -y : "+y);
			return true;
		}else{
			int idTile = map.getTileId((int)((x)/32),(int)((y)/32),cEVENT);
			String blocked = map.getTileProperty(idTile, "block", "non");
			if(blocked.equals("block")){
				return true;
			}else if(blocked.equals("eau") && !marcherSurLeau){
				return true;
			}else if(blocked.equals("escalade") && !escalade){
				return true;
			}else{
				for(ItemMap it:items){
					if(!it.isDestroy() && it.block() && it.getX() == (int)((x)/32) &&  it.getY() == (int)((y)/32)){
						return true;
					}
				}
				for(Ennemi en:ennemis){
					if(!en.isAlive() && en.getX() == (int)((x)/32) &&  en.getY() == (int)((y)/32)){
						return true;
					}
				}
				return false;
			}
		}
	}
	
	public boolean isEscalier(int x,int y){
		if(x>=640 || y>=480 || x<0 || y<0){
//			System.out.println("ERROR map-isEvent  x : "+x+" -y : "+y);
			return false;
		}else{
			int idTile = map.getTileId((int)((x)/32),(int)((y)/32),cEVENT);
			String event = map.getTileProperty(idTile, "block", "non");
			if(event.equals("escalier")){
				return true;
			}else if(event.equals("escalade")){
				return true;
			}
			return false;
		}
	}
	
	public boolean isEscalade(int x,int y){
		if(x>=640 || y>=480 || x<0 || y<0){
//			System.out.println("ERROR map-isEvent  x : "+x+" -y : "+y);
			return false;
		}else{
			int idTile = map.getTileId((int)((x)/32),(int)((y)/32),cEVENT);
			String event = map.getTileProperty(idTile, "block", "non");
			if(event.equals("escalade")){
				return true;
			}
			return false;
		}
	}
	
	public boolean isSurEau(int x,int y){
		if(x>=640 || y>=480 || x<0 || y<0){
			//System.out.println("ERROR map-isEvent  x : "+x+" -y : "+y);
			return false;
		}else{
			int idTile = map.getTileId((int)((x)/32),(int)((y)/32),cEVENT);
			String event = map.getTileProperty(idTile, "block", "non");
			if(event.equals("eau")){
				return true;
			}
			return false;
		}
	}
	
	public void ajouterEnnemi(Ennemi en){
		ennemisTemp.add(en);
	}
	
	public boolean isEvent(int x,int y){
		if(x>=640 || y>=480 || x<0 || y<0){
//			System.out.println("ERROR map-isEvent  x : "+x+" -y : "+y);
			return false;
		}else{
			int idTile = map.getTileId((int)((x)/32),(int)((y)/32),cEVENT);
			String event = map.getTileProperty(idTile, "event", "non");
			
			if(!event.equals("non")){
				
				if(event.equals("debloqueFeu") && !DebloqueFeu.getInstance().isFinish()){
					Game.event = DebloqueFeu.getInstance();
					return true;
				}else if(event.equals("debloqueEau") && !DebloqueEau.getInstance().isFinish()){
					Game.event = DebloqueEau.getInstance();
					return true;
				}else if(event.equals("debloqueTerre") && !DebloqueTerre.getInstance().isFinish()){
					Game.event = DebloqueTerre.getInstance();
					return true;
				}else if(event.equals("debloqueAir") && !DebloqueAir.getInstance().isFinish()){
					Game.event = DebloqueAir.getInstance();
					return true;
				}else if(event.equals("teleport")){
					int mapX = Integer.parseInt(map.getTileProperty(idTile, "mapX", "non"));
					int mapY = Integer.parseInt(map.getTileProperty(idTile, "mapY", "non"));
					int herosX  = Integer.parseInt(map.getTileProperty(idTile, "x", "non"));
					int herosY  = Integer.parseInt(map.getTileProperty(idTile, "y", "non"));
					Game.teleport(mapX, mapY, herosX, herosY);
					return true;
				}
				return false;
			}else{
				return false;
			}
		}
	}
	
	public void jouerMusique(){
		if(fog){
			if(m1.playing()){
				m1.stop();
				m2.loop();
			}else if(!m2.playing()){
				m2.loop();
			}
		}else{
			if(m2.playing()){
				m2.stop();
				m1.loop();
			}else if(!m1.playing()){
				m1.loop();
			}
		}
	}
	
	public static void stopMusique(){
		m1.stop();
		m2.stop();
	}
	
	public int getX(){
		return idMapX;
	}
	
	public int getY(){
		return idMapY;
	}
	
	public boolean isFog(){
		return fog;
	}
	
}
