package game;


import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;


public class TitleScreen extends BasicGameState
{
    public static final int ID = 2;
    private Graphics GRAPHIC;
    
    private Image fond_titre;
    private Image nouveau1, nouveau2,quitter1,quitter2;
    
    private int position;
    private Input input;
    
    private Sound son;
    
    @Override
    public int getID() {return ID;}
    
    public void init(GameContainer container, StateBasedGame game) throws SlickException {
    	this.GRAPHIC = container.getGraphics();
    	fond_titre = new Image("res/hud/title.png");
    	nouveau1 = new Image("res/hud/new_game2.png");
    	nouveau2 = new Image("res/hud/new_game.png");
    	quitter1 = new Image("res/hud/quit2.png");
    	quitter2 = new Image("res/hud/quit.png");
    	position = 0;
    	son = new Sound("res/sound/selec.wav");
    	
    	input = container.getInput();

    }
    public void render(GameContainer container, StateBasedGame game, Graphics g) throws SlickException {
    	GRAPHIC.drawImage(fond_titre,0,0);
    	if(position==0){
    		GRAPHIC.drawImage(nouveau2,100,310);
    		
    		GRAPHIC.drawImage(quitter1,100,330);
    	}else{
    		GRAPHIC.drawImage(nouveau1,100,310);
    		GRAPHIC.drawImage(quitter2,100,330);
    	}
    }
    public void update(GameContainer container, StateBasedGame game, int delta) throws SlickException {
    	if(input.isKeyPressed(input.KEY_DOWN)){
    		if(position<1){
    			position++;
    			son.play();
    		}
    	}else if(input.isKeyPressed(input.KEY_UP)){
    		if(position>0){
    			position--;
    			son.play();
    		}
    	}
    	
    	if(input.isKeyPressed(input.KEY_ENTER) || input.isKeyPressed(input.KEY_SPACE)){
    		if(position==0){
    			son.play();
    			game.enterState(3);
    			game.enterState(3, new FadeOutTransition (Color.black, 1000), new FadeInTransition (Color.black, 1000));
    		}else if(position==1){
    			
    			System.exit(0);
    		}
    	}
    }
}
